## ros-one-moveit-task-constructor-core 0.1.4-0jammy.20251023.1732

=== debian/changelog ===
ros-one-moveit-task-constructor-core (0.1.4-0jammy.20251023.1732) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Michael Goerner <me@v4hn.de>  Thu, 23 Oct 2025 17:32:28 +0000

ros-one-moveit-task-constructor-core (0.1.4-0jammy) jammy; urgency=high

  * Avoid duplicate scenes in Solution.msg from generator stages (#639 <https://github.com/moveit/moveit_task_constructor/issues/639>)
  * Allow max Cartesian link speed in PlannerInterface (#277 <https://github.com/moveit/moveit_task_constructor/issues/277>)
  * Enable collisions visualizations (#708 <https://github.com/moveit/moveit_task_constructor/issues/708>)
  * LimitSolutions wrapper stage (#710 <https://github.com/moveit/moveit_task_constructor/issues/710>)
  * Improve code documentation
  * CI: Fix Noble builds
  * Pick with custom max_velocity_scaling_factor during approach+lift
  * Rework pybind11 ABI compatibility checks
  * Remove pybind11 submodule
  * Upgrade pybind11 to v3
  * Modernize declaration of compile options
  * Factor out Python property handling to allow for reuse in custom Python wrappers
  * Fix clamping of joint constraints (#665 <https://github.com/moveit/moveit_task_constructor/issues/665>)
  * Correctly report failures instead of issueing console warnings
  * Increase minimum required CMake version to 3.16 supported by Ubuntu 20.04
  * Python API: Allow passing a task's introspection object to SolutionBase::toMsg()
  * clang-format-14
  * Add support for GenerateRandomPose
  * python: Add Task::setRobotModel
  * Add path_constraints property to Connect stage
  * provide a fmt wrapper (#615 <https://github.com/moveit/moveit_task_constructor/issues/615>)
  * Update API: JumpThreshold -> CartesianPrecision (#611 <https://github.com/moveit/moveit_task_constructor/issues/611>)
  * Reduce stop time due to preempt (#598 <https://github.com/moveit/moveit_task_constructor/issues/598>)
  * Add unittest for #581 <https://github.com/moveit/moveit_task_constructor/issues/581>
  * Fix early planning preemption (#597 <https://github.com/moveit/moveit_task_constructor/issues/597>)
  * MoveRelative: fix segfault on empty trajectory (#595 <https://github.com/moveit/moveit_task_constructor/issues/595>)
  * MoveRelative: handle equal min/max distance (#593 <https://github.com/moveit/moveit_task_constructor/issues/593>)
  * Cleanup unit tests and allow them to run via both, cmdline and pytest
  * Connect: Relax validity check of reached end state
  * Unify Python demo scripts
  * Switch shebang to python3
  * Silence gcc's overloaded-virtual warnings
  * Add property to enable/disable pruning at runtime (#590 <https://github.com/moveit/moveit_task_constructor/issues/590>)
  * Disable pruning by default
  * test_pruning.cpp: Add new test
  * test_pruning.cpp: Extend test to ParallelContainer
  * PassThrough: cleanup unused headers
  * Avoid segfault if TimeParameterization is not set
  * CartesianPath: allow ik_frame definition if start and end are given as joint-space poses
  * Generalize utils::getRobotTipForFrame() to return error_msg instead of calling markAsFailure() on a solution
  * ComputeIK: Allow additional constraints for filtering solutions (#464 <https://github.com/moveit/moveit_task_constructor/issues/464>)
  * Expose MultiPlanner to Python (#474 <https://github.com/moveit/moveit_task_constructor/issues/474>)
  * Add unittest cartesianCollisionMinMaxDistance (#538 <https://github.com/moveit/moveit_task_constructor/issues/538>)
  * Simplify formatting code with https://github.com/fmtlib (#499 <https://github.com/moveit/moveit_task_constructor/issues/499>)
  * Add NoOp stage (#534 <https://github.com/moveit/moveit_task_constructor/issues/534>)
  * ModifyPlanningScene: check state for collisions
  * Improve TypeError exceptions
  * Drop Melodic support
  * Switch to package py_binding_tools
  * Add ability to move CollisionObjects (#567 <https://github.com/moveit/moveit_task_constructor/issues/567>)
  * Improve description of max_distance property of Connect stage (#564 <https://github.com/moveit/moveit_task_constructor/issues/564>)
  * Add Generator::spawn(from, to, trajectory) variant (#546 <https://github.com/moveit/moveit_task_constructor/issues/546>)
  * Cosmetic fixes
  * Fix Solution::fillMessage() (#432 <https://github.com/moveit/moveit_task_constructor/issues/432>)
  * Fix generation of Solution msg: consider backward operation
  * Propagate errors from planners to solution comment (#525 <https://github.com/moveit/moveit_task_constructor/issues/525>)
  * JointInterpolationPlanner: Check joint bounds (#505 <https://github.com/moveit/moveit_task_constructor/issues/505>)
  * Add property trajectory_execution_info (#355 <https://github.com/moveit/moveit_task_constructor/issues/355>, #502 <https://github.com/moveit/moveit_task_constructor/issues/502>)
  * Clear JointStates in scene diff (#504 <https://github.com/moveit/moveit_task_constructor/issues/504>)
  * Set a non-infinite default timeout in CurrentState stage (#491 <https://github.com/moveit/moveit_task_constructor/issues/491>)
  * Add GenerateRandomPose stage (#166 <https://github.com/moveit/moveit_task_constructor/issues/166>)
  * GenerateGraspPose: Expose rotation_axis as property (#535 <https://github.com/moveit/moveit_task_constructor/issues/535>)
  * Connect: ensure end-state matches goal state (#532 <https://github.com/moveit/moveit_task_constructor/issues/532>)
  * Fix discontinuity in trajectory (#485 <https://github.com/moveit/moveit_task_constructor/issues/485>)
  * Adaptions for https://github.com/ros-planning/moveit/pull/3534
  * Cleanup debug output
  * Fix duplicate solutions
  * printPendingPairs(os) -> os<<pendingPairsPrinter()
  * Fix leaking of failures into enumerated solutions
  * Add more debugging output
  * Unit tests for #485 <https://github.com/moveit/moveit_task_constructor/issues/485>
  * DelayingWrapper stage to delay solution shipping in unit tests
  * Simplify tests


## ros-one-moveit-task-constructor-core 0.1.4-0noble.20251023.1752

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(moveit_task_constructor_core)

find_package(Boost REQUIRED)
find_package(fmt REQUIRED)
find_package(catkin REQUIRED COMPONENTS
	roslint
	tf2_eigen
	geometry_msgs
	moveit_core
	moveit_ros_planning
	moveit_ros_planning_interface
	moveit_task_constructor_msgs
	roscpp
	visualization_msgs
	rviz_marker_tools
	py_binding_tools
)

option(MOVEIT_CI_WARNINGS "Enable all warnings used by CI" OFF) # We use our own set of warnings
moveit_build_options()

catkin_python_setup()

catkin_package(
	LIBRARIES
		${PROJECT_NAME}
		${PROJECT_NAME}_stages
		${PROJECT_NAME}_stage_plugins
		${PROJECT_NAME}_python_tools
	INCLUDE_DIRS
		include
	CATKIN_DEPENDS
		geometry_msgs
		moveit_core
		moveit_task_constructor_msgs
		rviz_marker_tools
		visualization_msgs
)

set(CMAKE_VISIBILITY_INLINES_HIDDEN TRUE)

set(PROJECT_INCLUDE ${CMAKE_CURRENT_SOURCE_DIR}/include/moveit/task_constructor)

add_subdirectory(src)
add_subdirectory(python)
add_subdirectory(test)

install(DIRECTORY include/ DESTINATION ${CATKIN_GLOBAL_INCLUDE_DESTINATION}
	PATTERN "*_p.h" EXCLUDE)
install(FILES
	motion_planning_stages_plugin_description.xml
	DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION})

=== doc/requirements.txt ===
furo
lxml
sphinx
sphinx-copybutton

=== python/CMakeLists.txt ===
# pybind11 must use the ROS python version
set(PYBIND11_PYTHON_VERSION ${PYTHON_VERSION})
find_package(pybind11 3.0 REQUIRED)

# C++ wrapper code
add_subdirectory(bindings)

if(CATKIN_ENABLE_TESTING)
	find_package(rostest REQUIRED)

	# Add folders to be run by python nosetests
	if(DEFINED ENV{PRELOAD})
		message(WARNING "Skipping python tests due to asan")
	else()
		catkin_add_nosetests(test)

		# Add rostests
		add_rostest(test/rostest_mtc.test)
	endif()
endif()

roslint_python()

=== src/CMakeLists.txt ===
add_library(${PROJECT_NAME}
	${PROJECT_INCLUDE}/container.h
	${PROJECT_INCLUDE}/container_p.h
	${PROJECT_INCLUDE}/cost_queue.h
	${PROJECT_INCLUDE}/introspection.h
	${PROJECT_INCLUDE}/marker_tools.h
	${PROJECT_INCLUDE}/merge.h
	${PROJECT_INCLUDE}/moveit_compat.h
	${PROJECT_INCLUDE}/properties.h
	${PROJECT_INCLUDE}/stage.h
	${PROJECT_INCLUDE}/stage_p.h
	${PROJECT_INCLUDE}/storage.h
	${PROJECT_INCLUDE}/task.h
	${PROJECT_INCLUDE}/task_p.h
	${PROJECT_INCLUDE}/utils.h

	${PROJECT_INCLUDE}/solvers/planner_interface.h
	${PROJECT_INCLUDE}/solvers/cartesian_path.h
	${PROJECT_INCLUDE}/solvers/joint_interpolation.h
	${PROJECT_INCLUDE}/solvers/pipeline_planner.h
	${PROJECT_INCLUDE}/solvers/multi_planner.h

	container.cpp
	cost_terms.cpp
	introspection.cpp
	marker_tools.cpp
	merge.cpp
	properties.cpp
	stage.cpp
	storage.cpp
	task.cpp
	utils.cpp

	solvers/planner_interface.cpp
	solvers/cartesian_path.cpp
	solvers/joint_interpolation.cpp
	solvers/pipeline_planner.cpp
	solvers/multi_planner.cpp
)
target_link_libraries(${PROJECT_NAME} ${catkin_LIBRARIES} fmt::fmt)
target_include_directories(${PROJECT_NAME}
	PUBLIC $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
	PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
)
target_include_directories(${PROJECT_NAME} SYSTEM PUBLIC ${catkin_INCLUDE_DIRS})
add_dependencies(${PROJECT_NAME} ${catkin_EXPORTED_TARGETS})

add_subdirectory(stages)

install(TARGETS ${PROJECT_NAME}
	ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
	LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION})

=== test/CMakeLists.txt ===
#############
## Testing ##
#############

## Add gtest based cpp test target and link libraries
if (CATKIN_ENABLE_TESTING)
	find_package(rostest REQUIRED)

	add_library(gtest_utils gtest_value_printers.cpp models.cpp stage_mockups.cpp)
	target_link_libraries(gtest_utils ${PROJECT_NAME})

	macro(mtc_add_test TYPE)
		# Split ARGN into .test file and other sources
		set(TEST_FILE ${ARGN})
		set(SOURCES ${ARGN})
		list(FILTER TEST_FILE INCLUDE REGEX "\.test$")
		list(FILTER SOURCES EXCLUDE REGEX "\.test$")
		# Determine TARGET name from first source file
		list(GET SOURCES 0 TEST_NAME)
		string(REGEX REPLACE "\.cpp$" "" TEST_NAME ${TEST_NAME})
		string(REGEX REPLACE "_" "-" TEST_NAME ${TEST_NAME})
		# Configure build target
		if(TEST_FILE) # Add rostest if .test file was specified
			_add_rostest_google_test(${TYPE} ${PROJECT_NAME}-${TEST_NAME} ${TEST_FILE} ${SOURCES})
		else()
			_catkin_add_google_test(${TYPE} ${PROJECT_NAME}-${TEST_NAME} ${SOURCES})
		endif()
		target_link_libraries(${PROJECT_NAME}-${TEST_NAME} ${PROJECT_NAME} ${PROJECT_NAME}_stages gtest_utils gtest_main)
	endmacro()
	macro(mtc_add_gtest)
		mtc_add_test("gtest" ${ARGN})
	endmacro()
	macro(mtc_add_gmock)
		mtc_add_test("gmock" ${ARGN})
	endmacro()

	mtc_add_gmock(test_mockups.cpp)
	mtc_add_gtest(test_stage.cpp)
	mtc_add_gtest(test_limit_solutions.cpp)
	mtc_add_gtest(test_container.cpp)
	mtc_add_gmock(test_serial.cpp)
	mtc_add_gmock(test_pruning.cpp)
	mtc_add_gtest(test_properties.cpp)
	mtc_add_gtest(test_cost_terms.cpp)
	mtc_add_gtest(test_storage.cpp)

	mtc_add_gmock(test_fallback.cpp)
	mtc_add_gmock(test_cost_queue.cpp)
	mtc_add_gmock(test_interface_state.cpp)

	mtc_add_gtest(test_move_to.cpp move_to.test)
	mtc_add_gtest(test_move_relative.cpp move_relative.test)

	# building these integration tests works without moveit config packages
	add_executable(pick_ur5 pick_ur5.cpp)
	target_link_libraries(pick_ur5 ${PROJECT_NAME}_stages gtest)

	add_executable(pick_pr2 pick_pr2.cpp)
	target_link_libraries(pick_pr2 ${PROJECT_NAME}_stages gtest)

	add_executable(pick_pa10 pick_pa10.cpp)
	target_link_libraries(pick_pa10 ${PROJECT_NAME}_stages gtest)

	# running these integrations test naturally requires the moveit configs
	find_package(tams_ur5_setup_moveit_config QUIET)
	if(tams_ur5_setup_moveit_config_FOUND)
		add_rostest(pick_ur5.test)
	endif()
	find_package(pr2_moveit_config_FOUND QUIET)
	if(pr2_moveit_config_FOUND)
		add_rostest(pick_pr2.test)
	endif()
	find_package(pa10_shadow_moveit_config QUIET)
	if(pa10_shadow_moveit_config_FOUND)
		add_rostest(pick_pa10.test)
	endif()
endif()

=== python/bindings/CMakeLists.txt ===
set(INCLUDES ${PROJECT_SOURCE_DIR}/include/moveit/python/task_constructor)
add_library(${PROJECT_NAME}_python_tools SHARED
	${INCLUDES}/properties.h
	src/properties.cpp
)
target_link_libraries(${PROJECT_NAME}_python_tools PUBLIC ${PROJECT_NAME} pybind11::pybind11)
# Use minimum-size optimization for pybind11 bindings
target_link_libraries(${PROJECT_NAME}_python_tools PUBLIC pybind11::opt_size)

# catkin_lint cannot detect target declarations in functions, here in pybind11_add_module
#catkin_lint: ignore undefined_target

# moveit.task_constructor
pybind11_add_module(pymoveit_mtc
	src/solvers.cpp
	src/core.cpp
	src/stages.cpp
	src/module.cpp
)
target_link_libraries(pymoveit_mtc PUBLIC ${PROJECT_NAME} ${PROJECT_NAME}_stages ${PROJECT_NAME}_python_tools)
set_target_properties(pymoveit_mtc PROPERTIES LIBRARY_OUTPUT_DIRECTORY ${CATKIN_DEVEL_PREFIX}/${CATKIN_GLOBAL_PYTHON_DESTINATION})

# install libs
install(TARGETS ${PROJECT_NAME}_python_tools
	ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
	LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION})
install(TARGETS pymoveit_mtc
	LIBRARY DESTINATION ${CATKIN_GLOBAL_PYTHON_DESTINATION})

=== src/scope_guard/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.11) # for FetchContent
project(scope_guard)

# handle inclusions and dependencies
include(CheckCXXSymbolExists)
include(CheckCXXCompilerFlag)
include(GNUInstallDirs)

Include(FetchContent)

FetchContent_Declare(
        Catch2
        GIT_REPOSITORY https://github.com/catchorg/Catch2.git
        GIT_TAG        v2.13.6
)

FetchContent_MakeAvailable(Catch2)

# global configurations
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

# check for compiler support of noexcept in type
set(CMAKE_REQUIRED_FLAGS "-std=c++1z") # only for this check
CHECK_CXX_SYMBOL_EXISTS(__cpp_noexcept_function_type "" HAS_NOEXCEPT_IN_TYPE)
unset(CMAKE_REQUIRED_FLAGS)

# request C++11 explicitly by default - works around newer compilers otherwise
# omitting `-std=c++11` despite 11 being requested with target_compile_features
set(CMAKE_CXX_STANDARD 11)

# compiler warnings
if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
  set(clang_warnings "-Werror -Wall -Wextra -pedantic -Wno-c++98-compat \
    -Wno-unreachable-code -Wno-padded -Wno-exit-time-destructors \
    -Wno-global-constructors -Wno-unused-variable -Wno-unused-member-function \
    -Wno-unused-function -Wno-class-varargs")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${clang_warnings}")
elseif("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror -Wall -Wpedantic \
                                          -Wno-unused")
  if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS 10)
    # earlier versions complain of unused "nodiscard" results in unevaluated contexts
    # (https://gcc.gnu.org/bugzilla/show_bug.cgi?id=89070)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-error=unused-result")
  endif()

  check_cxx_compiler_flag("-Wnoexcept-type" HAS_NOEXCEPT_TYPE_WARNING)
  if(HAS_NOEXCEPT_TYPE_WARNING)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-noexcept-type")
  endif()

  option(ENABLE_COVERAGE "Enable coverage reporting" FALSE)
elseif("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC")
  if(CMAKE_CXX_FLAGS MATCHES "/W[0-4]")
    string(REGEX REPLACE "/W[0-4]" "/W4" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
  else()
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W4")
  endif()
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /WX")
endif()

# utility to derive a string with success or failure from boolean param
function(expect_str ret should_succeed)
  if(${should_succeed})
    set(${ret} "success" PARENT_SCOPE)
  else()
    set(${ret} "failure" PARENT_SCOPE)
  endif()
endfunction()

# utility to derive noexcept requirement status string from boolean param
function(noexc_str ret require_noexcept)
  if(${require_noexcept})
    set(${ret} "reqnoexc" PARENT_SCOPE)
  else()
    set(${ret} "allowexc" PARENT_SCOPE)
  endif()
endfunction()

# utility to derive standard number from boolean param
function(std_num ret use_cxx17)
  if(${use_cxx17})
    set(${ret} 17 PARENT_SCOPE)
  else()
    set(${ret} 11 PARENT_SCOPE)
  endif()
endfunction()

# utility to derive a string describing the c++ standard
function(std_str ret stdn)
  set(${ret} cpp${stdn} PARENT_SCOPE)
endfunction()

# utility to derive the c++ standard compile feature
function(std_ftr ret stdn)
  set(${ret} cxx_std_${stdn} PARENT_SCOPE)
endfunction()

# utility to derive strings for test configuration
function(derive_common_test_strings
         tst_ret exe_ret ftr_ret # out params
         base_name should_succeed cxx17 require_noexcept # in params
         )
  expect_str(expect ${should_succeed})
  noexc_str(noexc ${require_noexcept})
  std_num(stdn ${cxx17})
  std_str(std ${stdn})
  std_ftr(${ftr_ret} ${stdn})

  string(CONCAT ${exe_ret} ${base_name} "_" ${expect} "_" ${std} "_"
         ${noexc})
  string(CONCAT ${tst_ret} "test_" ${${exe_ret}})

  # return these
  set(${tst_ret} ${${tst_ret}} PARENT_SCOPE)
  set(${exe_ret} ${${exe_ret}} PARENT_SCOPE)
  set(${ftr_ret} ${${ftr_ret}} PARENT_SCOPE)
endfunction()

# utility to add executable and configure common properties
function(add_test_exe exe src ftr require_noexcept)
  add_executable(${exe} ${src})
  target_compile_features(${exe} PRIVATE ${ftr})
  if(${require_noexcept})
    target_compile_definitions(${exe} PRIVATE SG_REQUIRE_NOEXCEPT_IN_CPP17)
  endif()
endfunction()

# utility to add a batch of catch tests with the specified c++ standard and
# noexcept requirement
function(add_catch_tests_batch exe_ret src cxx17 require_noexcept)
  derive_common_test_strings(tst exe ftr # out params
      "catch_batch" TRUE ${cxx17} ${require_noexcept}) # in params
  add_test_exe(${exe} ${src} ${ftr} ${require_noexcept})
  target_link_libraries(${exe} PRIVATE Catch2::Catch2)

  add_test(NAME ${tst} COMMAND ${exe} "--order" "lex")

  set(${exe_ret} ${exe} PARENT_SCOPE) # return
endfunction()

# utility to add a compilation test, with the specified C++ standard and
# noexcept requirement, along with a success/failure expectation and a counter
# that identifies what parts of the code to activate
function(add_compilation_test src should_succeed cxx17 require_noexcept countid)
  derive_common_test_strings(tst exe ftr # out params
      "compilation" ${should_succeed} ${cxx17} ${require_noexcept}) # in params

  string(APPEND tst "_" ${countid})
  string(APPEND exe "_" ${countid})
  string(CONCAT def "test_" ${countid})
  add_test_exe(${exe} ${src} ${ftr} ${require_noexcept})

  # only build this when running tests (building _is_ the test)
  set_target_properties(${exe}
                        PROPERTIES EXCLUDE_FROM_ALL ON
                        EXCLUDE_FROM_DEFAULT_BUILD ON)

  # add macro to select active code section
  target_compile_definitions(${exe} PRIVATE ${def})

  # determine the test command
  set(tst_cmd ${CMAKE_COMMAND} --build . --target ${exe} --config $<CONFIG>)

  # if using MSBuild, prevent logo and warning summary
  if(${CMAKE_GENERATOR} MATCHES "[vV]isual [sS]tudio")
    list(APPEND tst_cmd -- /nologo /verbosity:minimal)
  endif()

  # create the test
  add_test(NAME ${tst}
           COMMAND ${tst_cmd}
           WORKING_DIRECTORY ${CMAKE_BINARY_DIR})

  # configure the test to expect compilation success or failure
  if(${should_succeed})
    set_tests_properties(${tst} # confirm no warnings in successful test
                         PROPERTIES FAIL_REGULAR_EXPRESSION "warn;Warn;WARN")
  else()
    set_tests_properties(${tst} PROPERTIES WILL_FAIL TRUE) # expect a failure
  endif()
endfunction()

# utility to determine whether a compilation test should expect building to fail
function(expect_result ret count cxx17 reqne)
  if(${count} LESS 35)
    set(${ret} TRUE PARENT_SCOPE)

  elseif(${count} LESS 52)
    if(${cxx17} AND ${reqne})
      set(${ret} FALSE PARENT_SCOPE)
    else()
      set(${ret} TRUE PARENT_SCOPE)
    endif()
  else()
    set(${ret} FALSE PARENT_SCOPE)
  endif()
endfunction()

set(cxx17_possibilities FALSE)
if(HAS_NOEXCEPT_IN_TYPE)
  list(APPEND cxx17_possibilities TRUE)
endif()

# actually add the tests
foreach(cxx17 ${cxx17_possibilities})
  foreach(reqne FALSE TRUE)
    # add catch tests for this standard/noexcept-requirement combination
    add_catch_tests_batch(catch_batch_exe catch_tests.cpp ${cxx17} ${reqne})

    if(ENABLE_COVERAGE) # configure catch tests for coverage if needed
      target_compile_options(${catch_batch_exe} PRIVATE --coverage -O0)
      target_link_libraries(${catch_batch_exe} PRIVATE --coverage)
    else() # only run compile time tests in non-coverage builds
      # add noexcept compilation tests for this standard/noexcept-requirement
      # combination
      foreach(count RANGE 71) # range inclusive in cmake (so 0 or 72 tests)
                              # 0-34: always succeed (0 = all test macros off)
                              # 35-51: fail when requiring noexcept
                              # 52-71: always fail
        expect_result(success ${count} ${cxx17} ${reqne})
        add_compilation_test(compile_time_tests.cpp
                             ${success} ${cxx17} ${reqne} ${count})
      endforeach()
    endif()
  endforeach()
endforeach()

add_custom_target(test_verbose COMMAND ${CMAKE_CTEST_COMMAND} --verbose)
enable_testing()

=== src/stages/CMakeLists.txt ===
add_library(${PROJECT_NAME}_stages
	${PROJECT_INCLUDE}/stages/modify_planning_scene.h
	${PROJECT_INCLUDE}/stages/fix_collision_objects.h

	${PROJECT_INCLUDE}/stages/current_state.h
	${PROJECT_INCLUDE}/stages/fixed_state.h
	${PROJECT_INCLUDE}/stages/fixed_cartesian_poses.h
	${PROJECT_INCLUDE}/stages/generate_pose.h
	${PROJECT_INCLUDE}/stages/generate_random_pose.h
	${PROJECT_INCLUDE}/stages/generate_grasp_pose.h
	${PROJECT_INCLUDE}/stages/generate_place_pose.h
	${PROJECT_INCLUDE}/stages/compute_ik.h
	${PROJECT_INCLUDE}/stages/passthrough.h
	${PROJECT_INCLUDE}/stages/noop.h
	${PROJECT_INCLUDE}/stages/predicate_filter.h
	${PROJECT_INCLUDE}/stages/limit_solutions.h

	${PROJECT_INCLUDE}/stages/connect.h
	${PROJECT_INCLUDE}/stages/move_to.h
	${PROJECT_INCLUDE}/stages/move_relative.h

	${PROJECT_INCLUDE}/stages/simple_grasp.h
	${PROJECT_INCLUDE}/stages/pick.h

	modify_planning_scene.cpp
	fix_collision_objects.cpp

	current_state.cpp
	fixed_state.cpp
	fixed_cartesian_poses.cpp
	generate_pose.cpp
	generate_random_pose.cpp
	generate_grasp_pose.cpp
	generate_place_pose.cpp
	compute_ik.cpp
	passthrough.cpp
	predicate_filter.cpp
	limit_solutions.cpp

	connect.cpp
	move_to.cpp
	move_relative.cpp

	simple_grasp.cpp
	pick.cpp
)
target_link_libraries(${PROJECT_NAME}_stages PUBLIC ${PROJECT_NAME} ${catkin_LIBRARIES})

add_library(${PROJECT_NAME}_stage_plugins
   plugins.cpp
)
target_link_libraries(${PROJECT_NAME}_stage_plugins ${PROJECT_NAME}_stages ${catkin_LIBRARIES})

install(TARGETS ${PROJECT_NAME}_stages ${PROJECT_NAME}_stage_plugins
	ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
	LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION})

=== debian/changelog ===
ros-one-moveit-task-constructor-core (0.1.4-0noble.20251023.1752) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Michael Goerner <me@v4hn.de>  Thu, 23 Oct 2025 17:52:15 +0000

ros-one-moveit-task-constructor-core (0.1.4-0noble) noble; urgency=high

  * Avoid duplicate scenes in Solution.msg from generator stages (#639 <https://github.com/moveit/moveit_task_constructor/issues/639>)
  * Allow max Cartesian link speed in PlannerInterface (#277 <https://github.com/moveit/moveit_task_constructor/issues/277>)
  * Enable collisions visualizations (#708 <https://github.com/moveit/moveit_task_constructor/issues/708>)
  * LimitSolutions wrapper stage (#710 <https://github.com/moveit/moveit_task_constructor/issues/710>)
  * Improve code documentation
  * CI: Fix Noble builds
  * Pick with custom max_velocity_scaling_factor during approach+lift
  * Rework pybind11 ABI compatibility checks
  * Remove pybind11 submodule
  * Upgrade pybind11 to v3
  * Modernize declaration of compile options
  * Factor out Python property handling to allow for reuse in custom Python wrappers
  * Fix clamping of joint constraints (#665 <https://github.com/moveit/moveit_task_constructor/issues/665>)
  * Correctly report failures instead of issueing console warnings
  * Increase minimum required CMake version to 3.16 supported by Ubuntu 20.04
  * Python API: Allow passing a task's introspection object to SolutionBase::toMsg()
  * clang-format-14
  * Add support for GenerateRandomPose
  * python: Add Task::setRobotModel
  * Add path_constraints property to Connect stage
  * provide a fmt wrapper (#615 <https://github.com/moveit/moveit_task_constructor/issues/615>)
  * Update API: JumpThreshold -> CartesianPrecision (#611 <https://github.com/moveit/moveit_task_constructor/issues/611>)
  * Reduce stop time due to preempt (#598 <https://github.com/moveit/moveit_task_constructor/issues/598>)
  * Add unittest for #581 <https://github.com/moveit/moveit_task_constructor/issues/581>
  * Fix early planning preemption (#597 <https://github.com/moveit/moveit_task_constructor/issues/597>)
  * MoveRelative: fix segfault on empty trajectory (#595 <https://github.com/moveit/moveit_task_constructor/issues/595>)
  * MoveRelative: handle equal min/max distance (#593 <https://github.com/moveit/moveit_task_constructor/issues/593>)
  * Cleanup unit tests and allow them to run via both, cmdline and pytest
  * Connect: Relax validity check of reached end state
  * Unify Python demo scripts
  * Switch shebang to python3
  * Silence gcc's overloaded-virtual warnings
  * Add property to enable/disable pruning at runtime (#590 <https://github.com/moveit/moveit_task_constructor/issues/590>)
  * Disable pruning by default
  * test_pruning.cpp: Add new test
  * test_pruning.cpp: Extend test to ParallelContainer
  * PassThrough: cleanup unused headers
  * Avoid segfault if TimeParameterization is not set
  * CartesianPath: allow ik_frame definition if start and end are given as joint-space poses
  * Generalize utils::getRobotTipForFrame() to return error_msg instead of calling markAsFailure() on a solution
  * ComputeIK: Allow additional constraints for filtering solutions (#464 <https://github.com/moveit/moveit_task_constructor/issues/464>)
  * Expose MultiPlanner to Python (#474 <https://github.com/moveit/moveit_task_constructor/issues/474>)
  * Add unittest cartesianCollisionMinMaxDistance (#538 <https://github.com/moveit/moveit_task_constructor/issues/538>)
  * Simplify formatting code with https://github.com/fmtlib (#499 <https://github.com/moveit/moveit_task_constructor/issues/499>)
  * Add NoOp stage (#534 <https://github.com/moveit/moveit_task_constructor/issues/534>)
  * ModifyPlanningScene: check state for collisions
  * Improve TypeError exceptions
  * Drop Melodic support
  * Switch to package py_binding_tools
  * Add ability to move CollisionObjects (#567 <https://github.com/moveit/moveit_task_constructor/issues/567>)
  * Improve description of max_distance property of Connect stage (#564 <https://github.com/moveit/moveit_task_constructor/issues/564>)
  * Add Generator::spawn(from, to, trajectory) variant (#546 <https://github.com/moveit/moveit_task_constructor/issues/546>)
  * Cosmetic fixes
  * Fix Solution::fillMessage() (#432 <https://github.com/moveit/moveit_task_constructor/issues/432>)
  * Fix generation of Solution msg: consider backward operation
  * Propagate errors from planners to solution comment (#525 <https://github.com/moveit/moveit_task_constructor/issues/525>)
  * JointInterpolationPlanner: Check joint bounds (#505 <https://github.com/moveit/moveit_task_constructor/issues/505>)
  * Add property trajectory_execution_info (#355 <https://github.com/moveit/moveit_task_constructor/issues/355>, #502 <https://github.com/moveit/moveit_task_constructor/issues/502>)
  * Clear JointStates in scene diff (#504 <https://github.com/moveit/moveit_task_constructor/issues/504>)
  * Set a non-infinite default timeout in CurrentState stage (#491 <https://github.com/moveit/moveit_task_constructor/issues/491>)
  * Add GenerateRandomPose stage (#166 <https://github.com/moveit/moveit_task_constructor/issues/166>)
  * GenerateGraspPose: Expose rotation_axis as property (#535 <https://github.com/moveit/moveit_task_constructor/issues/535>)
  * Connect: ensure end-state matches goal state (#532 <https://github.com/moveit/moveit_task_constructor/issues/532>)
  * Fix discontinuity in trajectory (#485 <https://github.com/moveit/moveit_task_constructor/issues/485>)
  * Adaptions for https://github.com/ros-planning/moveit/pull/3534
  * Cleanup debug output
  * Fix duplicate solutions
  * printPendingPairs(os) -> os<<pendingPairsPrinter()
  * Fix leaking of failures into enumerated solutions
  * Add more debugging output
  * Unit tests for #485 <https://github.com/moveit/moveit_task_constructor/issues/485>
  * DelayingWrapper stage to delay solution shipping in unit tests
  * Simplify tests


=== debian/control ===
Source: ros-one-moveit-task-constructor-core
Section: misc
Priority: optional
Maintainer: Michael Goerner <me@v4hn.de>
Build-Depends: debhelper (>= 9.0.0), libfmt-dev, python3-setuptools, ros-one-catkin, ros-one-geometry-msgs, ros-one-moveit-core, ros-one-moveit-ros-planning, ros-one-moveit-ros-planning-interface, ros-one-moveit-task-constructor-msgs, ros-one-py-binding-tools, ros-one-roscpp, ros-one-roslint, ros-one-rviz-marker-tools, ros-one-tf2-eigen, ros-one-visualization-msgs
Homepage: https://github.com/moveit/moveit_task_constructor
Standards-Version: 3.9.2

Package: ros-one-moveit-task-constructor-core
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libfmt-dev, ros-one-geometry-msgs, ros-one-moveit-core, ros-one-moveit-ros-planning, ros-one-moveit-ros-planning-interface, ros-one-moveit-task-constructor-msgs, ros-one-py-binding-tools, ros-one-roscpp, ros-one-rviz-marker-tools, ros-one-tf2-eigen, ros-one-visualization-msgs
Description: MoveIt Task Pipeline

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/one/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF -DCATKIN_ENABLE_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_configure -- \
		-DFETCHCONTENT_FULLY_DISCONNECTED=OFF \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/one" \
		-DCMAKE_PREFIX_PATH="/opt/ros/one" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-one-moveit-task-constructor-core//opt/ros/one/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_install

## ros-one-moveit-task-constructor-core 0.1.4-3jammy.20251213.2121

=== debian/changelog ===
ros-one-moveit-task-constructor-core (0.1.4-3jammy.20251213.2121) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Michael Goerner <me@v4hn.de>  Sat, 13 Dec 2025 21:21:25 +0000

## ros-one-moveit-task-constructor-core 0.1.4-3noble.20251213.2126

=== CMakeLists.txt ===
--- 
+++ 
@@ -14,6 +14,7 @@
 	roscpp
 	visualization_msgs
 	rviz_marker_tools
+	pybind11_catkin
 	py_binding_tools
 )

=== python/CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,3 @@
-# pybind11 must use the ROS python version
-set(PYBIND11_PYTHON_VERSION ${PYTHON_VERSION})
-find_package(pybind11 3.0 REQUIRED)
-
 # C++ wrapper code
 add_subdirectory(bindings)

=== python/bindings/CMakeLists.txt ===
--- 
+++ 
@@ -11,7 +11,7 @@
 #catkin_lint: ignore undefined_target
 
 # moveit.task_constructor
-pybind11_add_module(pymoveit_mtc
+pybind_add_module(pymoveit_mtc
 	src/solvers.cpp
 	src/core.cpp
 	src/stages.cpp

=== debian/changelog ===
ros-one-moveit-task-constructor-core (0.1.4-3noble.20251213.2126) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Michael Goerner <me@v4hn.de>  Sat, 13 Dec 2025 21:26:46 +0000

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: misc
 Priority: optional
 Maintainer: Michael Goerner <me@v4hn.de>
-Build-Depends: debhelper (>= 9.0.0), libfmt-dev, python3-setuptools, ros-one-catkin, ros-one-geometry-msgs, ros-one-moveit-core, ros-one-moveit-ros-planning, ros-one-moveit-ros-planning-interface, ros-one-moveit-task-constructor-msgs, ros-one-py-binding-tools, ros-one-roscpp, ros-one-roslint, ros-one-rviz-marker-tools, ros-one-tf2-eigen, ros-one-visualization-msgs
+Build-Depends: debhelper (>= 9.0.0), libfmt-dev, python3-setuptools, ros-one-catkin, ros-one-geometry-msgs, ros-one-moveit-core, ros-one-moveit-ros-planning, ros-one-moveit-ros-planning-interface, ros-one-moveit-task-constructor-msgs, ros-one-py-binding-tools, ros-one-pybind11-catkin, ros-one-roscpp, ros-one-roslint, ros-one-rviz-marker-tools, ros-one-tf2-eigen, ros-one-visualization-msgs
 Homepage: https://github.com/moveit/moveit_task_constructor
 Standards-Version: 3.9.2

## ros-one-moveit-task-constructor-core 0.1.4-4jammy.20251216.0001

=== debian/changelog ===
ros-one-moveit-task-constructor-core (0.1.4-4jammy.20251216.0001) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Michael Goerner <me@v4hn.de>  Tue, 16 Dec 2025 00:01:44 +0000

## ros-one-moveit-task-constructor-core 0.1.4-4jammy.20260128.2342

=== debian/changelog ===
ros-one-moveit-task-constructor-core (0.1.4-4jammy.20260128.2342) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Michael Goerner <me@v4hn.de>  Wed, 28 Jan 2026 23:42:08 +0000

## ros-one-moveit-task-constructor-core 0.1.4-4jammy.20260301.2343

=== debian/changelog ===
ros-one-moveit-task-constructor-core (0.1.4-4jammy.20260301.2343) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Michael Goerner <me@v4hn.de>  Sun, 01 Mar 2026 23:43:05 +0000

## ros-one-moveit-task-constructor-core 0.1.4-4noble.20251216.0000

=== debian/changelog ===
ros-one-moveit-task-constructor-core (0.1.4-4noble.20251216.0000) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Michael Goerner <me@v4hn.de>  Tue, 16 Dec 2025 00:00:10 +0000

## ros-one-moveit-task-constructor-core 0.1.4-4noble.20260129.0000

=== debian/changelog ===
ros-one-moveit-task-constructor-core (0.1.4-4noble.20260129.0000) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Michael Goerner <me@v4hn.de>  Thu, 29 Jan 2026 00:00:08 +0000

## ros-one-moveit-task-constructor-core 0.1.4-4noble.20260301.2334

=== debian/changelog ===
ros-one-moveit-task-constructor-core (0.1.4-4noble.20260301.2334) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Michael Goerner <me@v4hn.de>  Sun, 01 Mar 2026 23:34:37 +0000
